!<
!Illumin
!
!Usage:
!Illumin.x  <in.H >out.H 
!
!Input Parameters:
! in.H: reference model
! op: which operator to run
!
!Output Parameters:
! out.H: illumination map  
!
!
!Description:
!
!
!>
!%end of self-documentation
!-------------------------------------------------
!
!Author: Marie Clapp
!
!Date Created:Mon Mar  3 16:17:02 2003
!
!Purpose: 
!
!
program Illumin
  use sep
  use mpi_sep
  use wei_mig
  use wei_kxmig
	use wei_type

  use wei_cig
  use wei_ssf
  use wei_sll
  use wei_wem
  use wei_param

  use oc_global_mod
  use oc_utils_mod
  use oc_cgstep_mod
  use oc_filealgebra_mod
  use oc_filter_mod
  use oc_mpi_combine_mod

	implicit none
  integer :: nmx,nmy,npx,npy,nz,stat,mpierr,iverb,ierr,n,i
	integer :: maxmem
	real :: eps
	logical :: verb
	character(len=128) :: wght,name

  !----------------------------------------------------------------
  call MPI_INIT(stat)
  call set_no_putch()
  call sep_init()
  !----------------------------------------------------------------
  !! init params for MPI
  call MPI_COMM_SIZE(MPI_COMM_WORLD, n,ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, i,ierr)
  if(i==0) then
     call from_param("verb",verb,.false.)
write(0,*) "WHAT THE ",verb
     iverb=0;if(verb) iverb=1
     call MPI_SEP_SEND_ARGS(n,10,iverb)
  else
     call MPI_SEP_RECEIVE_ARGS()
  end if


	call from_param("eps",eps,.0001)
	call from_param("maxmem",maxmem,60000)

	call sep_close()
 

if(i==0) write(0,*)"b4 weimig_init"

    !----------------------------------------------------------------
   call weimig_init(SLin=weisll_init  &
   ,               WCin=weikxmign_init &
   ,                FKin=weiwem_init  &
   ,                FXin=weissf_init  &
   ,                IGin=weipcig_init )
   !----------------------------------------------------------------

  if(i==0) then
		write(0,*)"initializing wght1"
		name="Wght"; wght = oc_clone(.false., down%R,name, maxmem) !! data  residual

		write(0,*)"initializing wght2"
		call oc_assign(wght, real(rZERO), maxmem)
  end if

if(i==0) write(0,*)"b4 forward"
        stat = weimig(.false.,.false.,down%R,down%D &
        ,              SLop=weisll  &
       ,           WCop=weikxmign  &
       ,              FKop=weiwem &
       ,              FXop=weissf &
       ,              IGop=weipcig)

if(i==0) write(0,*)"b4 adjoint"
        stat = weimig(.true.,.false.,wght,down%D &
        ,              SLop=weisll  &
       ,           WCop=weikxmign  &
       ,              FKop=weiwem &
       ,              FXop=weissf &
       ,              IGop=weipcig)

  !----------------------------------------------------------------
  !! shutdown MPI
  call MPI_FINALIZE(ierr)
  !----------------------------------------------------------------
  call exit(0)


end program Illumin
