program interp_prep
use sep
use io_nfilt_sep
use lapfac
integer :: n(3)
real :: o(3),d(3)
character(len=128) :: label
integer :: nsz,npts,iloc(3)
real, allocatable :: model(:,:,:),input(:,:)
type(filter) :: filt
integer :: ipt
integer, external :: sreed
integer :: nlap

call sep_init(SOURCE)
call from_history("n1",nsz)
call from_history("n2",npts)
call from_param("n",n)
call from_param("o",o)
call from_param("nlap",nlap,6)
call from_param("d",d)
if(n1==4 .and. n(3) .eq. 1) call seperr("pts are 3-d model space is 2-D")
call sep_put_data_axis_par("out",1,n(1),o(1),d(1),"Depth")
call sep_put_data_axis_par("out",2,n(2),o(2),d(2),"X")
call sep_put_data_axis_par("out",3,n(3),o(3),d(3),"Y")

allocate(input(nsz,npts))
allocate(model(n(1),n(2),n(3)))

model=0.
if(4*npts*nsz .ne. sreed("in",input,size(input)*4)) &
  call seperr("trouble reading input")
  
do ipt=1,npts
  if(nsz==3) then
    iloc(1:2)=(input(1:2,ipt)-o(1:2))/d(1:2)+1.5
    iloc(3)=1
  else
    iloc(1:3)=(input(1:3,ipt)-o(1:3))/d(1:3)+1.5
  end if
  if( all (iloc > 0 ) .and.  all(iloc <= n)) then
     model(iloc(1),iloc(2),iloc(3))=input(nsz,ipt)
  end if
end do

call  srite("out",model,size(model)*4)

if(n(3)==1) then
!  filt=lapfac2(.0001,n(1),nlap)
!  filt%flt=-.999*filt%flt/sum(filt%flt)
  call allocatehelix(filt,1)
  filt%lag=(/1/)
  filt%flt=-.999
else
  call allocatehelix(filt,3)
  filt%lag=(/1,n(1),n(1)*n(2)/)
  filt%flt=-.3333
end if


    
if(.not. rite_filt("filt",filt,n)) &
  call seperr("trouble writing filter")


   
	









end program
