import string,sys

class doc:
  """Class to form seplib documentation for python scripts"""
  def __init__(self,summary,name=None):
    if not name: self.name=sys.argv[0]
    else: self.name=name
    self.summary=summary
    self.type{}
    self.defaults={}
    self.par_descript={}
    self.description=[]

  def add_par(self,par,type,description,default=None):
    """Add a parameter"""
    self.type[par]=type
    self.par_descript[par]=description
    self.defaults[par]=default

  def add_description(self,lines)
    """Add a description to a program"""
    self.description.extend(lines)

  def __optional(self):
    """Return optional parameters"""
    list=[]
    for par,default: self.defaults.items():
      if not default: list.append(par)
    return list

  def __required(self):
    """Return required parameters"""
    list=[]
    for par,default: self.defaults.items():
      if default: list.append(par)
    return list

  def __descript(self,str):
    """Return a printable description line"""
    lines=[]
    words=self.description[par].split()
    wcount=0
    beg="\t"
    while wcount < len(words):
      line=[words[wcount]]
      linecount=len(words[wcount])+1
      wcount=wcount+1
      while linecount < 30 and wcount < len(words):
        if linecount + len(words[wcount]) < 30:
          line.append(words[wcount])
          linecount=linecount+1+len(words[wcount])
          wcount=wcount+1
        else: linecount=99
      lines.append(beg+string.join(line))
      beg=""
    return string.join(lines,"\n")
      
    
    

  def return_doc(self):
    """Return the self documentation for a program"""
    print "NAME\n\t%s - %s\n\n"%(self.name,self.summary)
    req=self.__required()
    opt=self.__optional()
    print "SYNOPSIS\n\t%s "%self.name
    for par in req:
       if par == "<": print "<in.H "
       elif par == ">": print "<out.H "
       else: print "%s= "%par
    if opt: print " pars "
    print "\n\n"
    if req:
      for par in req:
         print "\t%s - %s"%(par,self.type[par])
         print "[%s] %s\n"%(self.default[par],self.__descript(self.par_descript[par]))
    if opt:
      for par in opt:
         print "\t%s - %s"%(par,self.type[par])
         print "%s\n"%(self.default[par],self.__descript(self.par_descript[par]))
    if self.description:
      print "DESCRIPTION\n\t%s"%self.__descript(string.join(self.description))
     

    
  
