import SEP.sepfile
import SEP.util
import SEP.spawn
import SEP.paths
import SEP.options
import SEP.prog
__author__ = "Robert G. Clapp"
__email__ = "bob@sep.stanford.edu"
__version = "2004.12.2"
                                                                                


class lloyd(SEP.options.par_group,SEP.prog.prog):
  """Class to do velocity selection  using a modified Lloyd's algorythm"""

  def __init__(self,name="Lloyd"):
    """Initialize the Lloyd velocity sellection program"""
    SEP.options.par_group.__init__(self,name)
    self.add_doc_params()

  def add_doc_params(self):
    """Add the parameters for the lloyd velocity selection program"""
    self.add_doc_param("verb",doc="Verbosity level",required=None)
    self.add_doc_param("nref",4,"Number of reference velocities")
    self.add_doc_param("vel_map","n","Whether or not output the selected velocity model")
    self.add_doc_param("min_region_pct",1.,"Minimum percentage of the velocity associated with given refernce" )
    self.add_doc_param("min_slow_dev",6.,"Minimum deviation percentage between reference velocityes")
    self.add_doc_param("niter_lloyd",30,"Number of non-linear iterations")
    self.add_doc_param("stdin",doc="Input sepfile")
    self.add_doc_param("stdout",doc="Output sepfile")
    
  def build_check_params(self):
    """Build the commands for the program"""
    SEP.prog.prog.__init__(self,"%s/%s"%(SEP.paths.sepbindir,"Lloyd_vel"),
      "Lloyd_vel", self.return_args(), self.param("verb"))
