import SEP.opt_vector
import SEP.opt_operator
import SEP.parfile
import SEP.parjob
import SEP.util
import SEP.parjob
import SEP.machine
import time
import string
__author__ = "Robert G. Clapp"
__email__ = "bob@sep.stanford.edu"
__version = "2004.12.2"
                                                                                


class oc_par_operator(SEP.opt_operator.oc_operator):
  """An operator class for simple coarse grain parallelization operators"""
                                                                                        
  def __init__(self,name,domain,range,parjob,**kw):
    SEP.opt_operator.oc_operator.__init__(self,name,domain,range,**kw)

    self.parjob=parjob
    self.parfiles=[]
    self.par=self.option("par",SEP.par.sep_pars(name=name))

    if not parjob.return_par_files().has_key("domain"):
      SEP.util.err("Parjob must be initialized with a domain file tag")
    if not parjob.return_par_files().has_key("range"):
      SEP.util.err("Parjob must be initialized with a range file tag")
    self.range=parjob.return_par_files()["range"]
    self.domain=parjob.return_par_files()["domain"]


  def run_forward(self,model,data,add=None,restart=None,extra=None):
    self.parjob.set_global_par_dict(self.forward_pars(add=add,
      restart=restart,extra=extra));

    self.parjob.update_parfile_dict("domain",
      self.domain.clone(name=model.name,usage="INPUT",restart=self.restart))

    self.parjob.update_parfile_dict("range",
      self.range.clone(name=data.name,usage="OUTPUT",restart=self.restart))

    self.parjob.run_job(restart)
    self.parjob.clean()
   
  def run_adjoint(self,model,data,add=None,restart=None,extra=None):
    self.parjob.set_global_par_dict(self.adjoint_pars(add=add,
      restart=restart,extra=extra))

    self.parjob.update_parfile_dict("domain",
      self.domain.clone(name=model.name,usage="OUTPUT",restart=self.restart))

    self.parjob.update_parfile_dict("range",
      self.range.clone(name=data.name,usage="INPUT",restart=self.restart))

     
    self.parjob.run_job(restart)
    self.parjob.clean()
