import os
import popen2
import sys
import time
import pwd
import SEP.util
import SEP.status
import SEP.spawn
import commands
import string
import pwd

__author__ = "Robert G. Clapp"
__email__ = "bob@sep.stanford.edu"
__version = "2004.12.2"
                                                                                



class jobs:
  """ A class for logging a series of commands"""

  def __init__(self,logdir,verb=0):
    """Initialize a logging objecto
 
        logdir - the directory we are logging in 
        verb   - integer spcifying when to be verbose. Jobs <= verb will be echoed

    """
    self.verb=verb
    self.logdir=logdir
    self.coms={}
    if verb >2:  SEP.spawn.run_wait("mkdir  -p  logdir")
    self.base="%s/%s."%(self.logdir,pwd.getpwuid(os.getuid())[0])
    self.log_com={}

  def wait(self,cmds,time=9999999999,verb=9999,logit=1,label=None,error=1,logfile=None):
     """Run a process wait for it to finish

       cmds - The commands to run (string or list)
       time - the ammount of time before killing (9999999999)
       verb - The verbosity level for this command
       logit- Wheter (1) or not None to log the command
       label- The label associated with this command
       error- Whether (1) or not (0) to give an error if the command files
       logfile-The file to write out to (if None it will be formed)


    """

     if int(verb)>int(self.verb): verb=None
     if logit==1: 
       if not logfile:logfile=self.logfile(cmds,label)[0]
       err=SEP.spawn.run_wait(cmds,oper_len=time,verb=verb,logfile=logfile,
         error=error)
     else:        err=SEP.spawn.run_wait(cmds,time,verb=verb,error=error)
     return err

  def logfile(self,cmds=None,label=None,old=None):
     """Return the logfile name for the command

        The logfile is formed from the cmd or label
        When multiple instances of the same label cmd, future instances are incremented

        If old is specified the logfile that last instance of command created will
        be returned
     
        Example:
          s.logfile(label="1") will return userid.1.0

     """
     if not label:
       if not cmds: SEP.util.err("Must provide cmds or label")
       label=cmds[0]
     if not self.coms.has_key(label): self.coms[label]=0
     if old: 
        label2="%s.%s"%(label,str(self.coms[label]-1))
     else:
        label2="%s.%s"%(label,str(self.coms[label]))
        if cmds: self.log_com[label2]=string.join(cmds)
        self.coms[label]=self.coms[label]+1
     return self.base+string.replace(label2,' ','_'),label2

  def clean(self):
    """Remove the log directory"""
    if self.logdir!="/tmp": SEP.spawn.run_wait(["rm","-rf",self.logdir])

  def print_logfile(self,label,nlines=15):
     """Print the status of a section"""
     SEP.util.msg("JOB=%s:\n"%label)
     if self.logdir=="/tmp": SEP.util.msg(" ")
     log,label=self.logfile(label=label,old=1)
     if self.log_com.has_key(label): SEP.util.msg("Command:%s"%self.log_com[label])
     if os.path.isfile(log):
       stat,out=commands.getstatusoutput("tail -%d %s"%(nlines,log))
#       if stat==0: SEP.util.msg("%s"%out)
       if stat==0: SEP.util.msg(out)
     else: SEP.util.err("Logfile %s doesn't exist"%log)
