import SEP.sep_socket
import SEP.status
import SEP.par_log
import SEP.machine
import os
import sys
import string
import time
import commands

class parjob:

#FINISHED

#WRITE
  def clean(self):

#OLD


  def __init__(self, job_class, status_class, mach_class, socket_class,files, pars,
    program=None,verb=0,command_func=None,resend_finished=None,attempts=2):
    """INitialize a parallel job"""

    self.jobs=job_class          #run jobs with logging
    self.status=status_class     #status of jobs
    self.mach=mach_class         #get the machines
    self.socket=socket_class     #socket class
    self.pars=pars               #the parameters
    self.files=files             #the parallel file
    self.not_first=None
    self.attempts=attempts       #number of attempts for each job

    if command_func==None: 
      if None==program: SEP.util.err("Must provide program or command_func")
      else:  self.command_func=None
    else: self.command_func=command_func

    self.program=program
    self.verb=verb
    self.shell="rsh"
    self.resend_finished=resend_finished
    self.server_string=self.socket.server_string()

    self.check_files()


  def the_coms(self,mach):
    """Build the remote commands to run for the parallel job"""


    #return up to len(machs) keys that haven't been started
    todo_list=self.status.get_by_status("todo",len(mach))
    if len(todo_list) < len(mach): 
      todo_list.extend(self.status.get_by_status("todo2",len(mach)-len(todo_list)))
       
    

    if todo_list == None: return None,None

    #match machlabel and key
    mach_send={}
    for i in range(len(todo_list)): mach_send[todo_list[i]]=mach[i]

    #match mach and key
    mach_label_send={}
    for key,mach in mach_send.items(): mach_label_send[key]=self.mach.machname[mach]
      

    #setup all of the parralel files for the job
    tag_job={}
    for key in mach_send.keys(): tag_job[key]=" "

    for file in self.files:
      tags=file.tags(mach_label_send)  #tupple  label:tag
      for key,tag in  tags.items(): tag_job[key]=tag_job[key]+" "+tag


    #time to build the commands
    run_this={}
    for key,mach in mach_send.items():
      self.status.update_status(key,["sent",mach_send[key]])
      job_string ="%s sep.jobid=%s %s "%(self.server_string,key,self.pars[key])
      job_string+="sep.mach_label=%s "%mach_send[key]
      if self.verb >0:
        if self.verb >2:
          SEP.util.msg("Sending job %s to %s "%(key,mach))
        else:
          SEP.util.msg("Sending job %s to %s pars=[%s]"%(key,mach,self.pars[key]))
      if self.command_func:
        run=self.command_func(key,job_string,tag_job[key].split())
      else:
        run="%s  sep.begin_par=1 sep.end_par=1"%(self.program)
        run+=" %s %s %s "%(self.pars[key],job_string,tag_job[key])
      run_this[key]=self.fix_rsh_com(self.mach.machs_from_labels([mach])[0], run)
    return run_this,mach_send

  def fix_rsh_com(self,mach,inp):
    list=inp.split()
    for c in list: 
      if c == '"': c="'"
    out=self.shell+" "+mach+' "'+string.join(list)+'"'
    return out

  
  def check_files(self):
    """ Check to make sure parallel files make sense"""
    found=0
    nsect=len(self.pars)
    for file in self.files:
      if file.type != "COPY":
        if nsect!=file.nsect:
          err = "Number of sections  %d not equal to number"
          err+= " of parts %d in file=%s" % (nsect,file.nsect,file.name)
          SEP.util.err(err)
        if found==0:
          type=file.type
          nsect=file.nsect
          found=1
        else:
          if type!=file.type:
            SEP.util.err( "File types not the same for all paralllel files")
    
  

  def  run_job(self):
    """ Start job loop """
   
    stat=self.start_jobs()
    if stat== None: SEP.util.err("No jobs to run")
    elif stat == "Finished":  
      self.collect()
      self.cleanup()
      sys.exit(0)
    self.socket.run_server(self.action,self.check_status)
    self.cleanup()

  def cleanup(self):
     """Cleanup when finished"""
     for file in self.files: file.remove_it()
                                                                                     

  def record(self,jobid,machid,extra):
     """" Record that a task is running"""
     if self.verb >2:
        SEP.util.msg("     Job %s on %s registerd"%(jobid,machid))
     self.mach.update_status(machid,[jobid,extra]) #record that we started a job
     self.status.update_status(jobid,["running",machid])
     self.status.write_status() 
     self.start_jobs()
     return 1
      

  def start_jobs(self):
    """ Start a series of jobs """
    commands,err=self.build_commands()
    if err == "Run":
      for key,cm in commands.items(): 
         if self.not_first:
            time.sleep(2) #give time for socket to start up
            self.no_first=1 
         pid=os.fork()
         if not pid: #child process starts jobs
           error=self.jobs.wait(string.split(cm),verb=3,error=None,label=key)
           time.sleep(4) #give time for the job to be recorded by the master
           stat=self.status.get_key_status_elem(key,0)
           if error or stat!="finished":
             print "Job failure!!!"
             if stat!="finished": self.jobs.print_status(key)
             self.status.add_failure(key)
             count=self.status.get_failures(key)
             self.mach.mark_job_fail(key)
             if count==self.attempts: self.status.update_status(key,["fail"])
             else: self.status.update_status(key,["todo2"])
           sys.exit(0)
    return err

  def finish(self,mach_list):
    """Mark that a job is finished"""
    for mach in mach_list: self.update_status(mach,["free"])
    return err

  def build_commands(self):
     """Build commands to run on free nodes"""
     machines=self.mach.free()  #get initial list of machines
     todo_list=self.status.get_by_status("todo")
     todo_list.extend(self.status.get_by_status("todo2"))
     if not todo_list: return None,"Finished"
     if not machines: return  None,"Full"
     commands,mach_label=self.the_coms(machines)
     if commands == None: return None,"Error"
     self.mach.assign(mach_label)  #assign machines
     return commands,"Run"

      
  def finish(self,jobid,machid,extra):
     """ Mark job as finished"""
     self.mach.update_status(machid,["free","none"])      #machine is free
     for file in self.files: file.done([jobid])
     self.status.update_status(jobid,["finished",machid])
     self.status.write_status() 
     stat=self.start_jobs()
     if self.verb>0:   SEP.util.msg(" Finished  %s on %s "%(jobid,machid))
     if stat == "Finished":
        if not self.status.get_by_status("running"):
          if not self.status.get_by_status("sent"):
            not_collected=self.status.status_not(["collected"])
            if not_collected != None:
              for file in self.files: file.finish()
              self.collect()
            return 0
     if stat == "Error": return None 
     return 1  
     

  
  def collect(self):
     """Collect the data for all nodes where a process isn't currently running"""
     i=0;
     key_list=[]
     mach_dict=self.status.get_other_dict(self.status.get_by_status("finished"))
     running=self.mach.get_by_status("running")
     running.extend(self.mach.get_by_status("sent"))
     running=self.mach.machs_from_labels(running)
     for key,val in mach_dict.items():
       if running.count(val) ==0 : key_list.append(key)
     if len(key_list)>0:
       for file in self.files: file.collect(key_list,[" "])
     self.status.write_status() 

  def action(self,msg):
     """Perform actions based on node returns"""
     oper,jobid,machid,extra=self.decode_action(msg)
     if   oper== 'record':  status=self.record(jobid,machid,extra)
     elif oper== 'finish':  status=self.finish(jobid,machid,extra)
     elif oper== 'progress':  status=self.progress(jobid,machid,extra)
     elif oper== 'alive': return 1
     elif oper== 'error':  status=self.error(jobid,machid,extra)
     return status

  def progress(self,jobid,machid,extra):
    """Register progress in a job"""
    if self.verb >1:
        SEP.util.msg("  Job %s on %s progress=%s"%(jobid,machid,extra))
    self.status.update_status(jobid,["running",machid,extra])
    return 1

  def error(self,id,machid,extra):
     """Error when running job"""
     file=self.jobs.logfile(id)
     if os.path.isfile(file):
        out=commands.getoutput("tail -2 "+file)
        SEP.util.msg("Identifier %s: ERROR %s \n%s"%(id,machid,out))
        SEP.util.err("Error detected")
     else: SEP.util.err("Logfile %s doesn't exist"%file)


  def check_status(self):
     """Update node status and try to start more jobs"""

     #see if any machines that died are back up
     a=self.status.get_by_status("fail")
     if a: 
      SEP.util.err("Failed to start \"%s\" %d times. Giving up"%(a[0],self.attempts))
     mach_list=self.mach.get_by_status("dead")
     for m in mach_list:
        alive=self.mach.check_alive(m)
        if alive ==0:
          list=self.mach.label_list(m)
          for i in list: self.mach.set_status(i,"free")
     
     #get a dictionary key:mlabel
     other_dict=self.status.get_other_dict(self.status.return_keys())

     #get a dictionary key:status
     status_dict=self.status.get_other_dict(self.status.return_keys())

     #see if any machines that are up are now down
     mach_list=self.mach.machs_from_labels(self.mach.status_not(["dead"]))
     for m in mach_list:
       alive=SEP.machine.check_alive(m)
       if alive !=0:
         list=self.mach.label_list(m)
ABAD BAD BAD
         for i in list: 
           self.mach.set_status(i,"dead") #set the machine dead
           for key,label in other_dict.items():
             if label ==  i: #if this section was on this mlabel
               if status_dict[key] == "sent" or status_dict[key] =="running":
                 self.update(key,"todo","none")
               elif status_dict[key] == "finished"  and resend_finished:
                 self.update(key,"todo","none")
               
     #try to start more jobs
     err=self.start_jobs()
     if err == "Error": SEP.util.err("Trouble starting jobs")

  def decode_action(self,msg):
     """Decode the actions returned by the server"""
     parts=msg.split(":")
     return parts[0],parts[1],parts[2],parts[3]
     

class complex_par_job(parjob):

  def __init__(self, pars, isect, files, usage, axis, mfile, server="192.168.100.2",
    port_num=None, verb=None, func=None, program=None, shared=None, type=None,
     log_level=0, logdir="/tmp", status_file="status", reuse_par=None,
    restart=None,attempts=2,mach_status="status.mach"):


    if program==None and function==None:
      SEP.util.err("Must provide function or program")

    self.run_class=SEP.par_logs.jobs(log_level,verb)
    self.mach_class=SEP.machine.sep_machine(mach_status,mfile=mfile)
    self.socket=SEP.sep_socket.sep_server(self.mach_class,master_ip=server,
       port=port_num)
    self.status=SEP.status.par_status(status_file,pars.keys())


    pars_out=self.status.update_pars(pars,restart)
    self.files=[]
    axis_out={}
    shared_out={}
    type_out={}
    reuse_out={}
 

    for par in pars.keys():
      if not isect.has_key(par): SEP.util.err("%s not a key in isect list"%par)

    for tag,file in files.items():
      if not usage.has_key(tag): SEP.util.err("%s must have usage specified"%tag)
      if axis.has_key(tag): axis_out[tag]=axis[tag]
      check=1
      if shared:
        if shared.has_key(tag): check=0
      if check==1:
         if not axis.has_key(tag):SEP.util.err("%s must have axis specified"%tag)
      else: 
        axis_out[tag]=None
      type_out[tag]="BLOCK"
      shared_out[tag]=None
      reuse_out[tag]=None
      if type:
        if type.has_key(tag): type_out[tag]=type[tag]
      if shared:
        if shared.has_key(tag): shared_out[tag]=shared[tag]
      if reuse_par:
        if reuse.has_key(tag): reuse_out[tag]=reuse_out[tag]

      self.files.append(SEP.parfile.parfile(file,tag,isect,usage[tag],
        self.mach_class,self.run_class,axis_out[tag],verb=verb,
        restart=restart, status=self.status,shared=shared_out[tag],type=type_out[tag]))


    SEP.parjob.parjob.__init__(self,self.run_class,self.status,self.mach_class,
     self.socket,self.files,pars_out,command_func=func,program=program,verb=verb,attempts=attempts)



class simple_par_job(complex_par_job):

  def __init__(self, nsect, files, par, usage, axis, mfile,
    server="192.168.100.2", port_num=None, verb=None, func=None, program=None,
    shared=None, type=None,  log_level=0, logdir="/tmp",
    status_file="status", reuse_par=None, restart=None,attempts=2,mach_status="status.mach"):

   pars={}
   isect={}
   for i in range(nsect):
     pars[str(i)]=par
     isect[str(i)]=i
   complex_par_job.__init__(self, pars, isect, files, usage, axis, mfile, server,
    port_num, verb, func, program,  None,None,log_level,logdir, status_file, 
    reuse_par,restart,attempts,mach_status)

