import os
import SEP.util
import SEP.spawn
import SEP.par
__author__ = "Robert G. Clapp"
__email__ = "bob@sep.stanford.edu"
__version = "2004.12.2"
                                                                                
class job:
  """A class for running/restarting a job"""
  def __init__(self,name,restart_opt=""):
     """Initialize a job object"""
     self.name=name
     self.restart_op=restart_opt

  def get_name(self,prefix=""):
    """The name of the job"""
    return "%s%s"%(prefix,self.name)

  def run_job(self,restart=None,par=None):
    """Run the job, possibly restarting"""
    SEP.util.err("Run job must be overwritten")

class prog(job):
  """A simple wrapper class for running a program"""

  def __init__(self,program,name=None,args=None,verb=None,restart_com=""):
    """Initialize a program object

        program the path to the program
        name - the identifies for the program (defaults to the basename of prog)
        args - the basic arguments for the program
        verb - whether or not to be verbose when running programs
        restart_com -Special options when restarting

    """
    self.program=program
    if name: self.name=name
    elif self.program: self.name=os.path.basename(program)
    else: SEP.util.err("Must provide either program or name")
    job.__init__(self,name)
    if args: self.args=args
    if verb: self.prog_verb=verb
    else: self.prog_verb=None
    self.restart_com=restart_com

  def set_args(self,args):
    """Set the arguments for the program"""
    self.args=args

  def run_job(self,restart=None,aa=None):
    """Run a program with checking for failure

    """
    if not os.path.isfile(self.program):
      SEP.util.err("%s does not exist or is not accessible"%self.program)
    temp_file=SEP.util.temp_file("prog_com")
    args=SEP.par.sep_pars(name=self.name)
    if aa: args.add_pars(aa)
    if self.args: args.add_pars(self.args)
    beg=""
    end=""
    v,e=args.par("stdin",delete=1)
    if e==1: beg="<%s"%v
    v,e=args.par("stdout",delete=1)
    if e==1: end=">%s"%v


    SEP.spawn.run_wait("%s %s %s %s"%(beg,self.program,
      args.return_sep_par_string(),end),
     logfile=temp_file,verb=self.prog_verb)
    SEP.spawn.run_wait("rm %s"%temp_file,error=None,quiet=1)
  def clean_files(self):
    """Clean up any intermediate files"""

class pipe(job):
  """A simple wrapper class for running a piped program"""

  def __init__(self,programs,name=None,args=[],verb=None,restart_com=""):
    """Initialize a program object

        programs the pathes to the programs []
        name - the identifies for the program (defaults to the basename of prog)
        args - the basic arguments for each program
        verb - whether or not to be verbose when running programs
        restart_com -Special options when restarting

    """
    self.programs=programs
    if name: self.name=name
    elif self.programs: self.name=os.path.basename(prorams[0])
    else: SEP.util.err("Must provide either program or name")
    job.__init__(self,name)
    if args: self.args=args
    if verb: self.prog_verb=verb
    else: self.prog_verb=None
    self.restart_com=restart_com

  def run_job(self,restart=None,aa=None):
    """Run a program with checking for failure

    """
    if not os.path.isfile(self.program):
      SEP.util.err("%s does not exist or is not accessible"%self.program)
    temp_file=SEP.util.temp_file("prog_com")

    if self.args: 
      if len(self.args) != len(self.programs): 
        SEP.util.err("Args and programs not the size")

    coms=[]
    beg=""
    end=""
    for i in range(len(self.programs)):
      prog=self.programs[i]
      arg=SEP.par.sep_pars(name=self.name)
      if aa: arg.add_pars(aa)
      if self.args:  
        arg.add_pars(self.args[i])

      v,e=arg.par("stdin",delete=1)
      if e==1: beg="<%s"%v
      v,e=arg.par("stdout",delete=1)
      if e==1: end=">%s"%v
      coms.append("%s %s"%(prog,arg.return_sep_par_string()))

    SEP.spawn.run_wait("%s %s %s"%(beg,string.join(coms,"|"),end),
     logfile=temp_file,verb=self.prog_verb)
    SEP.spawn.run_wait("rm %s"%temp_file,error=None,quiet=1)
