import os,sys,time,pwd,string,types,popen2
import SEP.util
import commands
print_all=None
__author__ = "Robert G. Clapp"
__email__ = "bob@sep.stanford.edu"
__version = "2004.12.2"
                                                                                



def run_wait(cmd,oper_len=9999999.,verb=None,logfile=None,sleep_interv=5,error=1,quiet=None,ntrys=1):
    """Run a command

        cmd            can be a string or a list
        oper_len       is the length of time before killing the given process
        verb           write command before running it
        logfile        write stderr and stdout to given file
        sleep_interv   sleep interval when waiting for a job to finish
        error          give an error if the command fails
        quiet          don't report stderr,stdout if it fails
        ntrys          Number of times to try the operation

    """
    if type(cmd)==types.ListType: cmd=string.join(cmd)
    if logfile: cmd=('(%s)>&%s'%(cmd,logfile))
    else:       cmd='(%s)>&/dev/null'%cmd
    if verb or print_all: SEP.util.msg("time:%s cmd=%s"%(str(oper_len),cmd))
    itry=0
    while itry < ntrys:
      itry=itry+1
      tmpg=SEP.util.temp_file("good")
      tmpb=SEP.util.temp_file("bad")
      pid=os.fork() 
      mytime=time.time()+oper_len
      if pid: #mastder thread
        stime=.2
        while  time.time() < mytime:
          if  os.path.isfile(tmpg) or os.path.isfile(tmpb): break
          time.sleep(stime)
          if stime < sleep_interv: stime=stime+.2
      else:
        stat,out=commands.getstatusoutput(cmd)
        if stat==0: stat,out=commands.getstatusoutput("touch %s"%tmpg)
        else:  stat,out=commands.getstatusoutput("touch %s"%tmpb)
        sys.exit(0)
      if not os.path.isfile(tmpg):
        os.kill(pid,9)
        if logfile:
          try: f=open(logfile)
          except:  return 1
          line=f.readline()
          while line:
            if not quiet: SEP.util.msg(line.rstrip())
            line=f.readline()
          f.close()
        if error and itry+1==ntrys: 
          SEP.util.err("ERR:Killed or died pid=%d\n%s\n"%(pid,cmd))
        elif not quiet: SEP.util.msg("WARN:Killed or died pid=%d\n%s\n"%(pid,cmd))
        stat,out=commands.getstatusoutput("rm %s %s"%(tmpg,tmpb))
        if itry+1== ntrys :return 1 
      else: 
        os.waitpid(pid,0)
        stat,out=commands.getstatusoutput("rm %s %s"%(tmpg,tmpb))
        return None
