import re
import string
import pwd
import sys
import os
import time
import SEP.par
import SEP.sepfile
import SEP.datapath
import SEP.util
from math import *

def  section_n_o_d(isect,nsect,pattern,n,o,d):
    if pattern == "BLOCK":
      j=1
      nt=0
      nremain=int(n)
      f=0
      i=0
      for i in range(isect+1):
        nt=ceil(int(nremain)/(int(nsect)-i))
        nremain-=int(nt);
        f=int(nt)+int(f);
      nout=nt;
      f-=nt;
    elif pattern == "SPREAD":
      j=nsect
      f=isect
      nout=floor(n/nsect)
      nremain=n - nout*nsect
      if nremain!=0:
        if isect < nremain: nout+=1;
    elif pattern == "COPY":
      nout=1
      f=0
      j=1
    else:
      SEP.util.err( "Uknown distribution type "+pattern)
    oout=float(o)+float(d)*int(f)
    dout=float(d)*int(j)
    return nout,oout,dout


class sep_section(SEP.sepfile.sep_file):

  def __init__(self,isect,mach,file=None,name=None,sepfile=None,remote=None,fmt=None,fake=0):
    if sepfile and not name: name=sepfile.name+"_sect%d"%isect
    SEP.sepfile.sep_file.__init__(self,sepfile=sepfile,file=file,name=name,fmt=fmt,remote=remote) 
    self.isect=isect
    self.mach=mach
    self.fake=fake

class sep_dff(SEP.par.sep_pars):
  """Extension of sep_par class that handles the dff file"""
 
  def __init__(self,file=None,name=None,sepfile=None,nsect=None,pattern=None,axis=None):
    SEP.par.sep_pars.__init__(self,file,name,sepfile)
    if nsect==None:
      nsect,err=self.par("nsect")
      if err==0: nsect=0
    self.set_nsect(nsect)
    if pattern==None:
      pattern,err=self.par("pattern")
      if err==0: pattern="BLOCK"
    self.set_pattern(pattern)
    if axis==None:
      axis,err=self.par("axis")
      if err==0: axis=-1
    self.set_axis(axis)

  def set_naxis(self,n):
    """Set naxis value"""
    self.add_param("naxis_convert",n,"int")
   

  def set_section(self,isect,tag,mach,fake=0):
    self.add_param("tag_sect"+str(isect),tag)
    self.add_param("mach_sect"+str(isect),mach)
    if isect>= self.nsect:  self.set_nsect(isect+1)
    self.add_param("fake_sect"+str(isect),fake)

  def set_nsect(self,nsect):
    self.add_param("nsect",nsect,type="int")
    self.nsect=nsect

  def set_pattern(self,pattern):
    self.add_param("pattern",pattern)
    self.pattern=pattern

  def set_axis(self,axis):
    self.add_param("axis",axis,type="int")
    self.axis=axis


class superset(SEP.sepfile.sep_file):
  def __init__(self,file=None,supersetfile=None,name=None,fmt=None,sepfile=None):
    """Initialize a superset file"""
    if supersetfile:
      SEP.sepfile.sep_file.__init__(self,file,supersetfile,name,fmt=fmt)
    else:
      SEP.sepfile.sep_file.__init__(self,file,sepfile,name,fmt=fmt)
    self.sections={}
    self.dff=None
    if supersetfile:
      if supersetfile.dff != None:
        self.dff=SEP.superset.sep_dff(name=name,sepfile=supersetfile.dff)
    else:
      dffname,err=self.history.par("dff")
      if err == 1 and dffname != "-1":
        self.dff=SEP.superset.sep_dff(name=name,file=dffname)
        for i in range(int(self.dff_par("nsect")[0])):
           val1,err1=self.dff_par("tag_sect"+str(i))
           val3,err3=self.dff_par("mach_sect"+str(i))
           val2,err2=self.dff_par("fake_sect"+str(i))  
           if err2==0: val2=0
           if err1 ==1 and int(val2)==0:
             self.sections[str(i)]=SEP.superset.sep_section(i,val3,name=val1,
               remote="%s:%s"%(str(val3),str(val1)))

  def dff_par(self,par):
     """Grab a parameter from a dff file"""
     if not self.dff: 
       SEP.util.err("Requesting a parameter from uninitialized dff")
     return self.dff.par(par)

  def add_dff_par(self,par,value,type="str"):
     """Set a parameter in a dff file"""
     if not self.dff: 
       SEP.util.err("Requesting a parameter from uninitialized dff")
     return self.dff.add_param(par,value,type)

  def section_size(self,isect):
    """Return the size of a section"""
    if self.dff.pattern=="COPY": return self.size()
    if not self.sections.has_key(str(isect)):
      SEP.util.msg("Section %d hasn't been created name=%s"%(isect,self.name))
      return 0
    return self.sections[str(isect)].size()


  def write_file(self,base=None):
    """Write a superset file to disk"""
    if base==None: file=self.name
    else: file=base
    SEP.sepfile.sep_file.write_file(self,base)
    if self.dff != None:
      self.dff.write_pars(file+"@@@@@@")

  def clean(self):
    """Clean a superset file"""
    args={}
    self.remove(args)

  def remove(self,args):
    """Remove superset file"""
    val,err=self.history_par("in")
    file_list=[]
    file_list.extend(add_parts(self.history))
    if self.header: file_list.extend(add_parts(self.header))
    if self.grid: file_list.extend(add_parts(self.grid))
    if self.dff: file_list.append(self.dff.name)
    all_erase=SEP.util.erase_list(file_list,args)
    if all_erase==1:
      if self.sections:
        remote_list={}
        for key,sect in self.sections.items():
          if sect.fake == 0:
            tag,err=self.dff_par("tag_sect"+key)
            mach,err2=self.dff_par("mach_sect"+key)
            if err==1 and err2==1:
              if not remote_list.has_key(mach):remote_list[mach]=""
              remote_list[mach]+="%s "%tag
        SEP.util.remote_erase(args,remote_list)
                                                                                      
  def create_dff(self,axis,nsect,dtype="BLOCK"):
    """Create a dff file for the given dataset"""
    
    dffname=self.history.name+"@@@@@@"
    self.modify_sepfile(axis,nsect,dtype,dffname)
    self.dff=SEP.superset.sep_dff(name=dffname,
      nsect=nsect,pattern=dtype,axis=axis)
    self.dff.set_naxis(self.axis(axis)[0])
    for i in range(nsect):
      self.dff.set_section(i,"dummy","dummy",fake=1)
    self.add_history_par("in","-1")

  def modify_sepfile(self,axis,nsect,dtype,dff_name):
    """Modify the sepfile according to dff parameters (and error checking)"""
    ndim=self.ndims()
    if axis < 1 and dtype!="COPY": 
       SEP.util.err("Axis must be greater than 0")
    if dtype=="BLOCK" or dtype=="SPREAD":
      if ndim < axis: SEP.util.err("Axis %d larger than ndims=%d for %s"%(axis,ndim,self.name))
      n,o,d,label,unit=self.axis(axis)
      if n < nsect: 
        SEP.util.err("nsect=%d is greater than axis(%d) length=%d file=%s"%(nsect,axis,n,self.history.name))
    elif dtype!="COPY":
      SEP.util.err( dtype+"=dtype, I understand only COPY, BLOCK, and SPREAD")
    self.add_history_par("dff",dff_name)

  def create_section(self,mach,isect,sect,fake):
    """Create a section"""
    if not fake: fake=0
    self.add_dff_par("tag_sect%d"%isect,sect)
    self.add_dff_par("mach_sect%d"%isect,mach)
    self.add_dff_par("fake_sect%d"%isect,fake,type="int")
    if fake==1:
      if self.sections.has_key(str(isect)): del self.sections[str(isect)]
      self.sections[str(isect)]= sep_section(isect,mach,sepfile=self,fake=1)
      if self.dff.pattern!="COPY":
        n,o,d,label,unit=self.sect_axis(isect)
        self.sections[str(isect)].set_axis(self.dff.axis,n,o,d,label,unit)
    else: 
      self.sections[str(isect)]=sep_section(isect,mach,remote="%s:%s"%(mach,sect),fake=0)

  def sect_axis(self,isect):
    """Return the n,o,d,label,unit for the distributed axis given section number"""
    n,o,d,label,unit=self.axis(self.dff.axis)
    n,o,d=section_n_o_d(isect,self.dff.nsect,self.dff.pattern,n,o,d)
    return n,o,d,label,unit
  def size(self):
     a=0
     for sect in self.sections.values(): a=a+sect.size()
     return a


  def set_axis(self,iax,n,o,d,label="",unit=""):
    """Set axis to given n,o,d,label, and unit"""
    SEP.sepfile.sep_file.set_axis(self,iax,n,o,d,label,unit)
    if self.dff != None:
      if self.dff.axis == iax: self.dff.set_naxis(n)
      
     
def add_parts(sep):
  list=[]
  list.append(sep.name)
  arg,err=sep.par("in")
  if err==1 and arg !="-1":
    files=arg.split(";")
    for file in files: list.append(file)
  return list

