import SEP.sepfile
import SEP.util
import SEP.spawn
import SEP.paths
import SEP.prog
import SEP.options

__author__ = "Robert G. Clapp"
__email__ = "bob@sep.stanford.edu"
__version = "2004.12.2"
                                                                                


class transp(SEP.options.par_group,SEP.prog.prog):
  """Class to do tranpose"""

  def __init__(self):
    """Initialize the Transpose"""
    SEP.option.par_group.__init__(self,"Transp")
    self.add_doc_params()

  def add_doc_params(self):
    """Add the parameters for the lloyd velocity selection program"""
    self.add_doc_param("plane","12","Plane to transpose")
    self.add_doc_param("maxsize",100,"Approximate memory to use")
    self.add_doc_param("verb",doc="Whether to be verbose (0 or 1)",required=None)
    self.add_doc_param("reshape",doc="Treat the cube dimensions differently")
    self.add_doc_param("stdin",doc="Input sepfile")
    self.add_doc_param("stdout",doc="Output sepfile")
    
  def build_check_params(self):
    """Build the commands for the program"""
    SEP.prog.prog.__init__(self,"%s/%s"%(SEP.paths.sepbindir,"Transp"),
      "Transp",self.return_args(),self.param("verb"))
