#!/usr/bin/env python
import SEP.util.err
import sys,string,re,commands
import SEP.pars


class wem_component:
  def __init__(self,modname,operator,init,code,extra=None):
    self.operator=operator
    self.init=init
    self,mod_name=modname
    self.type=None
    self.name=operator
    self.extra=extra
    if not os.path.isfile(code):
      SEP.util.err("File %s doesn't exist")
    self.code=code
  def component_check(self,component):
    return 1
  def copy_code(self,dir)
    SEP.spawn.run(["cp",self.code,dir])
    if self.extra: for a in self.extra: SEP.spawn.run(["cp",a,dir])
    
class fk(wem_component):
  def __init__(self,modname,operator,init,code):
     wem_component.__init__(self,modname,operator,init,code)
     self.type="fk"
class fx(wem_component):
  def __init__(self,modname,operator,init,code):
     wem_component.__init__(self,modname,operator,init,code)
     self.type="fx"
class ig(wem_component):
  def __init__(self,modname,operator,init,code):
     wem_component.__init__(self,modname,operator,init,code)
     self.type="ig"
class sl(wem_component):
  def __init__(self,modname,operator,init,code):
     wem_component.__init__(self,modname,operator,init,code)
     self.type="sl"
class wc(wem_component):
  def __init__(self,modname,operator,init,code,fks,fxs):
     wem_component.__init__(self,modname,operator,init,code)
     self.type="wc"
     self.fks=fk
     self.fxs=fx
  def component_check(self,components):
    if not self.fks.has_key(components["fk"].name)
      SEP.util.err("%s doesn't understand fk=%s, understands fks=[%s]"%(self.name,
        components["fk"].name,string.join(self.fks))
    if not self.fxs.has_key(components["fx"].name))
      SEP.util.err("%s doesn't understand fx=%s, understands fxs=[%s]"%(self.name,
        components["fx"].name,string.join(self.fxs)))
    return 1
class down(wem_component):
  def __init__(self,modname,operator,init,code,modes):
     wem_component.__init__(self,modname,operator,init,code)
     self.modes=modes
     self.type="down"

class simple_package:
  def __init__(self,name,libdirs,libs,includedirs=None):
    self.libdirs=libdirs
    self.libs=libs
    self.includedir=includedir
    self.name
  def return_lib_line(self):
    lineout=""
    for dir in self.libdir: lineout+=" -L%s "%dir
    for lib in self.libs  : lineout+=" -l%s "%lib
    return lineout
  def return_inc_line(self):
    lineout=""
    if  self.includedir:
    for inc in self.includedir  : lineout+=" -I%s "%inc
    return lineout
    


class wem_code:
  """Wem code object"""
  def __init__(self,components,progname,base_code,packages):
    """Initialize wem code object"""
    self.comp_name=["sl","wc","fk","sl","fx","ig"]
    self.op_name="down"
    self.packages=packages
    names=[self.op_name]
    self.base_code=base_code
    for val in self.comp_name: names.append(val)
    for elem in components: self.component[elem.type]=elem
    for name in names:  
      if  not self.components,has_key(name):
        SEP.util.err("wem_basic not initialized with %s",name)
    for comp in self.components.values():
       self.component_check(components)
    binbase=re.compile("(.+).x$").search(progname)
    self.name:self.progname
    if not binbase: SEP.util.err("Expecting program(%s) to end with .x"%progname)
    progbase=binbase.group(1)
    self.basename=os.path.basename(progbase)
    binS=re.compile("(.+)"+self.basename).search(progbase)
    if binS: self.bindir=binS.group(1)
    else: self.bindir=os.getcwd()
    self.build_main(prog,dir)
    self.build_make(prog,dir,options)

  def code_dir(self,dir):
    """Copy the code for a wem program"""
    SEP.spawn.run(["mkdir","-p",dir])
    for comp in self.components.values(): self.copy_code()
    if self.base_code: for a in self.base_code: SEP.spawn.run(["cp",a,dir])

  def build_main(self,dir):
     """Build the main program"""
     prog="%s%s%s.f90"%(dir,os.path.sep,self.basename)
     try: f = open(prog,"w")
     else: SEP.util.err("Trouble opening %s for writing"%prog)
     f.write("Program %s\n"%self.basename)
     f.write("  use sep")
     for comp in self.components.values(): f.write("  use %s\n"%comp.mod_name)
     f.write("  implicit none")
     f.write("  logical             :: adj,add \n")
     f.write("  character(len=128)  :: mod,data \n"\n\n);

     f.write("  call sep_init(SOURCE)\n")
     f.write("  call getch_add_string("head=/dev/null")\n")
     f.write("  call getch_add_string("noheader=y")\n")
     f.write("  call from_param("adj",adj,.true.)\n")
     f.write("  call from_param("add",add,.false.)\n")
     f.write("  R='R'\n")
     f.write("  D='D'\n")


     f.write("  %s (  &\n"%self.components[self.op_name].init")
     for comp in self.comp_name:
       f.write("      %sin=%s \n"%(self.components[comp].type,self.compoents[comp].init)
     f.write("      )\n")

     f.write("  %s (  &\n"%self.components[self.op_name].op")
     for comp in self.comp_name:
       f.write("      %sop=%s \n"%(self.components[comp].type,self.compoents[comp].op)
     f.write("      )\n\n\n\nend program")
     f.close()

     
  def build_make(dir,options):
     """Build the makefile"""
     make="%s%s%s.f90"%(dir,os.path.sep,self.basename)
     try: f = open(make,"w")
     f.write("include ${SEPINC}/SEP.top\n")
   
     f.write(%s%s%s.x:  "%(self.bindir,os.path.sep,self.basename))
     for key,val in options: 
       f.write("%s=%s\n"%(key,val))
     f.write("UF90INCLUDES=%s ")

     for pack in self.packages: 
       f.write(pack.return_inc_line)
     f.write("\nUF90LIBS=%s ")
     for pack in self.packages: 
       f.write(pack.return_lib_line)

     f.write("\n\n\nall:%s\n\n\n"%self.name)
     f.write("include ${SEPINC}/SEP.bottom\n")

  def build_source(self,dir,options=None):
    """Generate a makefile and the code the build an executable"""
    self.copy_dir(dir)
    self.build_main(dir)
    self.build_make(dir,options)
  
  def build(self,dir,options=None): 
    self.build_source(dir,options) 
    SEP.util.run_wait('cd dir; make all'.split())


class wem_operator(SEP.opt_operator.simple_operator):
  """Class that treats the migration as an operator"""
  def __init__(self,name,pars,restart=None):
    """Initialize the wem operator"""
    SEP.opt_operator.simple_operator.__init__(self,pars,datatag="D=",modeltag="R=",restart=restart)
    self.model_check={}
    self.data_check={}
    self.verb=self.pars.par("verb",0)
    if int(self.verb)==0 or str(self.verb)[0]=='n': self.verb=None

  def add_params(self,pars):
    """Add and check parameters"""
    SEP.opt_operator.simple_operator.add_params(self,pars)
    val,err = self.pars.par("S")
    if err !=1: SEP.util.err("Expecting slowness in the form S=file.H")
    slow=SEP.superset.superset(file=val)
    self.check_wavespace()
    self.check_slow(slow)

  def check_slow(self,slow):
    """Check to make sure the slowness make sense"""
    if slow.header or slow.grid:
      SEP.util.err("Expecting slowness to be a regular SEPlib file")
    if slow.ndims()!=3: SEP.util.err("Expecting slowness to be a 3-D file x,y,z")
    if slow.par("n1")[0] > 1:
       b,e=slow.axis_min_max(1)
       b1=self.pars.par("wave_x_min")[0]
       e1=self.pars.par("wave_x_max")[0]
       if b >b1: SEP.util.msg("Warning: Slowness axis 1 will be extended (neg) by %f "%(b-b1)
       if e <e1: SEP.util.msg("Warning: Slowness axis 1 will be extended (pos) by %f "%(e1-e)
    if slow.par("n2")[0] > 1:
       b,e=slow.axis_min_max(2)
       b1=self.pars.par("wave_y_min")[0]
       e1=self.pars.par("wave_y_max")[0]
       if b >b1: SEP.util.msg("Warning: Slowness axis 2 will be extended (neg) by %f "%(b-b1)
       if e <e1: SEP.util.msg("Warning: Slowness axis 2 will be extended (pos) by %f "%(e1-e)

  def check_model(self,model):
    """Check to see if the model makes sense"""
    if model_check.has_key(model.name): return
    if model.headers or model.grid:
      SEP.util.err("Model %s should be a regular dataset"%model.name
    self.axis_check("Model",model,1,"mx")
    self.axis_check("Model",model,2,"my")
    self.axis_check("Model",model,3,"hx")
    self.axis_check("Model",model,4,"hy")
    self.axis_check("Model",model,5,"z_")
    model_check[model.name]=1

  def axis_check(self,name,sep,axis,label):
    """Check to see if the axis makes sense"""
    n,o,d,label,unit=sep.axis(axis)
    if n>1: 
      n2=self.pars.par("a%s_n"%label)
      o2=self.pars.par("a%s_o"%label)
      d2=self.pars.par("a%s_d"%label)
      SEP.sepfile.axis_same("%s(%s) axis %d"%(name,sep.name,axis),n,o,d,label,n2,o2,d2)

  def check_data(self,data):
    """Check to see if the data makes sense"""
    if data_check.has_key(data.name): return
    if data.headers or data.grid:
      SEP.util.err("Data %s should be a regular dataset"%data.name
    self.axis_check("Data",data,1,"amx_")
    self.axis_check("Data",data,2,"amy_")
    self.axis_check("Data",data,3,"ahx_")
    self.axis_check("Data",data,4,"ahy_")
    self.axis_check("Data",data,5,"az__")
    data_check[data.name]=1
    


  def check_wavespace(self):
    """Check to make sure wavespace is described"""
    nmx,omx,dmx = check_wave_axis("amx_")
    nmy,omy,dmy = check_wave_axis("amy_")
    nhx,ohx,dhx = check_wave_axis("ahx_")
    nhy,ohy,dhy = check_wave_axis("ahy_")
    nz,oz,dz = check_wave_axis("az__")
    nw,ow,dw = check_wave_axis("aw__")

    bm,em= SEP.sepfile.min_max(nmx,omx,dmx)
    bh,eh= SEP.sepfile.min_max(nhx,ohx,dhx)
    if abs(bh) > abs(eh) : mx=abs(bh)
    else mx=abs(eh)
    self.pars.add_param("wave_x_min",bm-mx)
    self.pars.add_param("wave_x_max",em+mx)

    bm,em= SEP.sepfile.min_max(nmy,omy,dmy)
    bh,eh= SEP.sepfile.min_max(nhy,ohy,dhy)
    if abs(bh) > abs(eh) : mx=abs(bh)
    else mx=abs(eh)
    self.pars.add_param("wave_y_min",bm-mx)
    self.pars.add_param("wave_y_max",em+mx)

    z,err=self.pars.par("nzb",1)
    w,err=self.pars.par("nwb",1)
    if nz/z != int(float(nz)/float(z)): 
      SEP.util.err("nzb(%d) is not a factor of %d "%(z,nz))
    if nw/w != int(float(nw)/float(w)): 
      SEP.util.err("nwb(%d) is not a factor of %d "%(w,nw))

  def check_wave_axis(self,par,ndef=None,odef=None,ddf=None):
    """Return the n,o,d [with possible defaults for a wavespace axis"""
    n,err=self.pars.par("%n"%par,ndef)
    if err==0: SEP.util.err("Required parameter %sn missing"%par)
    o,err=self.pars.par("%o"%par,ndef)
    if err==0: SEP.util.err("Required parameter %so missing"%par)
    d,err=self.pars.par("%d"%par,ndef)
    if err==0: SEP.util.err("Required parameter %sd missing"%par)
    return int(n),float(o),float(d)

  def create_model(self,name):
    """Create the model structure"""
    do_real=self.image_par("image_real","n")[0]
    if str(do_real)[0]=="y" or  str(do_real)[0]=="1":do_real=1
    else: do_real=None
    return create_file(name,["mx","my","hx","hy","z_"],do_real)

  def create_data(self,name):
    """Create the data structure"""
    return create_file(name,["mx","my","hx","hy","z_"])

  def create_file(self,name,axes,do_real=None)
    if do_real: junk=SEP.opt_vector.opt_vector_float(name=name)
    else:       junk=SEP.opt_vector.opt_vector_complex(name=name)
    for i in range(len(axes)):
       n,o,d=self.get_wave_axis("mx")
       junk.set_axis(i,n,o,d,"mx","none")
    return junk

  def get_wave_axis(self,par):
    """Return aX_n, aX_o, aX_d"""
    n=self.pars.par("a%s_n"%par)[0] 
    o=self.pars.par("a%s_o"%par)[0] 
    d=self.pars.par("a%s_d"%par)[0] 
    return n,o,d
  
       

class wem(wem_operator):
  """Basic wem object"""
  def __init__(self,code,pars,restart=none):
    self.code=code
    temp_dir= os.path.getcwd()+os.path.sep+"tmp"
    self.code.build(temp_dir)
    SEP.spawn.run_wait("rm -rf temp_dir".split())
    wem_operator.__init__(self,self.code.name,pars,restart=restart)

class wem_migration(wem):
  """WEM  migration"""
  def __init__(self,code,pars,restart=None):
    wem.__init__(self,code,pars,restart=restart)
    mtag,err1=self.pars.par("M")
    dtag,err2=self.pars.par("D")
    if err1==0: SEP.util.err("When doing migration must provide model (M)")
    if err2==0: SEP.util.err("When doing migration must provide data (D)")
    self.data=opt_vector.opt_vector_complex(tag=mtag)
    self.check_data(data)
    if self.verb: SEP.util.msg("Initializing/reading a model")
    self.model=self.create_model(mtag)
    if not restart: self.model.zero()
    self.restart=restart
  def migrate(self):
    """Run a migration"""
    self.run_adjoint(self.model,self.data,restart=restart)

class wem_modeling(wem):
  """WEM  migration"""
  def __init__(self,code,pars,restart=None):
    wem.__init__(self,code,pars,restart=restart)
    mtag,err1=self.pars.par("M")
    dtag,err2=self.pars.par("D")
    if err1==0: SEP.util.err("When doing migration must provide model (M)")
    if err2==0: SEP.util.err("When doing migration must provide data (D)")
    esize=self.model.history_par("esize",4)[0]
    if int(esize)==4: self.model=opt_vector.opt_vector_float(tag=mtag)
    else: self.model=opt_vector.opt_vector_complex(tag=mtag)
    self.model=SEP.superset.superset(file=mtag)
    self.check_model(model)
    if self.verb: SEP.util.msg("Initializing/reading a data")
    self.data=self.create_data(dtag)
    if not restart: self.data.zero()
    self.restart=restart
  def model(self):
    """Run a modelling job"""
    self.run_forward(self.model,self.data,restart=restart)
  
    




