#!/usr/bin/env python
import commands,string,sys
import SEP.par
import SEP.superset
import SEP.wei_oper
import SEP.wei_code
import SEP.cgstep
import SEP.solver
import SEP.util
import marie_mig
import marie_util
import marie_reg_prec
import marie_solver
import marie_datum

args=SEP.par.sep_args()
SEP.util.debug=1
SEP.spawn.print_all=1

migrate=marie_util.logic("migrate",args)
datum=marie_util.logic("datum",args)
dottest=marie_util.logic("dottest",args)
if not datum:
  mig_op=marie_mig.mig_oper(args,migrate)
#if not migrate:
#  datum_op=marie_datum.datum_op(args)



if migrate:
	mig_op.migrate()
	sys.exit(0)
elif datum:
    datum_op.datum(None)
    sys.exit(0)
else:
  verb=marie_util.logic("verb",args)
  restart=marie_util.logic("restart",args)
  if restart:
    args.del_par("restart")

  #create the data object
  D=args.par("D",error=1)[0]
  data=SEP.sep_vector.scmplx(D,tag=D)

  #create the model object
  R=args.par("R",error=1)[0]
  if restart:
    model=SEP.sep_vector.scmplx(R,tag=R)
  else:
    model=mig_op.create_model(R)

  prec=marie_util.logic("prec",args)
  geol=marie_util.logic("geol",args)
  if prec and geol:
    prec_op =marie_reg_prec.prec_geol_op(args,model)
  elif prec:
    prec_op =marie_reg_prec.prec_op(args,model)
  else:
    reg_op =marie_reg_prec.reg_op(args,model)

  W,err=args.par("W")
  if err==1:
    par=SEP.par.sep_pars(name="AA")
    par.add_param(">","/dev/null")
    par.add_param("wt",W)
    wop=SEP.operator.oc("/net/koko/marie/bin/LINUX/Wt_op.x",data,data,pars=par)
  else:
    wop=None

  mmov=args.par("mmov")[0]
  rmov=args.par("rmov")[0]

if dottest:
   if mig_op.dot_test(): SEP.util.err("Failed migration dot test")
   if prec_op.dot_test(): SEP.util.err("Failed preconditioning dot test")
else:
  niter=int(args.par("niter",0)[0])
  eps=float(args.par("eps",1.)[0])
  step=SEP.cgstep.cgstep("matcg")
  if args.logic("eps_zero"):
    solver=marie_solver.twerp("/scr1/marie/prec_mig",model,data,mig_op,prec_op,
      step,niter, verb=verb,restart=restart,wop=wop,mmov=mmov,rmov=rmov)
  elif prec:
    solver=marie_solver.prec("/scr1/marie/prec_mig",model,data,mig_op,prec_op,step,niter,
     eps,verb=verb,restart=restart,wop=wop,mmov=mmov,rmov=rmov)
  else:
   solver=marie_solver.reg("/scr1/marie/reg_mig",model,data,mig_op,reg_op,step,niter,
     eps,verb=verb,restart=restart,wop=wop,mmov=mmov,rmov=rmov)

  if not solver.solve():
	   SEP.util.err( "Trouble iterating")

