#!/usr/bin/env python
import commands,string,sys
import SEP.par
import SEP.superset
import SEP.wei_oper
import SEP.wei_code
import SEP.spawn
import SEP.util

def extract_pars(pars,prefix):
  out=SEP.par.sep_par(name=prefix)
  srS=re.compile("%s(\S+)"%prefix)
  for key,val in pars.return_dict().items():
    b=srS.search(key)
    if b: out.add_param(b.group(1),val)
  return out



def mig_args(args):
  D=SEP.superset.superset(file=args.par("D")[0])
  S=SEP.superset.superset(file=args.par("S")[0])
  n,o,d,label,unit=D.axis(1)
  args.add_string("amx_n=%d amx_o=%f amx_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(2)
  args.add_string("amy_n=%d amy_o=%f amy_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(3)
  args.add_string("ahx_n=%d ahx_o=%f ahx_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(4)
  args.add_string("ahy_n=%d ahy_o=%f ahy_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(5)
  args.add_string("aw__n=%d aw__o=%f aw__d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=S.axis(3)
  args.add_param("az__n",args.par("az__n",n)[0])
  args.add_param("az__o",args.par("az__o",o)[0])
  args.add_param("az__d",args.par("az__d",d)[0])
  return args


args=SEP.par.sep_args()

clean=args.par("clean",0)
verb=args.par("verb",0)
if verb==0: verb=None


ident=args.par("ident",error=1)[0]
vel_tag=args.par("vel_in",error=1)[0]
vel=SEP.superset.superset(file=vel_tag)
vel_mig="vel_mig.%s.H"%ident
args.add_param("S",vel_mig)

if vel.ndims()==2:
  SEP.spawn.run_wait(("Transp   < %s |Transp >%s plane=23 "%(vel_tag,vel_mig)).split(),
   logfile=SEP.util.temp_file(),verb=verb)
else:
  SEP.spawn.run_wait(("Transp   < %s  >%s plane=13 "%(vel_tag,vel_mig)).split(),
   logfile=SEP.util.temp_file(),verb=verb)
                                                                                           
wei_comp=([SEP.wei_code.migz,SEP.wei_code.pspi,SEP.wei_code.ssf,
  SEP.wei_code.hcig,SEP.wei_code.sll])


mig=args.par("mig_type","Phase")[0]
if mig=="Phase": 
  wei_comp.append(SEP.wei_code.wem)
  prog="/net/koko/bob/bin/LINUX/Phase.x"
elif mig=="CAM": 
  wei_comp.append(SEP.wei_code.cam)
  prog="/net/koko/bob/bin/LINUX/CAM.x"
else: SEP.util.err("Unknown mig_type, must be Phase or CAM")



fft=SEP.wei_code.simple_package("fft",["/usr/local/FFTW/FFTW3/lib"],
  ["fftw3f"])
sep=SEP.wei_code.simple_package("sep",["/net/koko/bob/SEPI/lib"],
  ["sepauxf90","sepaux","sep2df90","sepparf90","seppar","sepgeef90",
    "supersetf90","sep3df90","sepf90","superset","sep3d","sep"])
                                                                                           
                                                                                           
base_dir="/homes/sep/bob/Src/lib/wei_single"
prog=SEP.wei_code.wei_code(wei_comp,prog,base_dir,SEP.wei_code.base_code,
  [sep,fft],"build")
options={}
options["UF90DEFINES"]="-DUSE_FFTW -DSEP_TIMER "
options["UF90FLAGS"]="-O3 -axP -tpp7"



#prog.build(options)

args=mig_args(args)
image,image_exist=args.par("image")
if image_exist==0:image="image_tmp.H"


restart,err0=args.par("restart")
if err0==1: args.del_par("restart")
 
image0,err0=args.par("image_zero")
 
migration,err_mig=args.par("migration")
 
image,image_exist=args.par("image","image_tmp.H")
args.add_param("R",image)
 
if 0==image_exist and err0==0 and err_mig==0:
  SEP.util.err("Must provide image, image_zero, and/or migration")

mig=SEP.wei_oper.wei_migration(prog,args,logdir="/scr1/bob/wei",restart=restart)
mig.migrate()

if err0==1:
  SEP.spawn.run_wait(("Window3d  min3=0. n3=1 < %s >%s "%(image,image0)).split(),
   logfile=SEP.util.temp_file(),verb=verb)

if err_mig==1:
  SEP.spawn.run_wait(("Transp reshape=2,4,5 plane=13 < %s >a.H "%image).split(),
   logfile=SEP.util.temp_file())
  SEP.spawn.run_wait("OFF2ANG  %s  < a.H >%s "%(args.par_string(),mig), 
    logfile=SEP.util.temp_file(),verb=verb)
  SEP.spawn.run_wait(("Rm3d a.H".split()),logfile=SEP.util.temp_file(),verb=verb)
if clean==1:
  SEP.spawn.run_wait(("Rm3d %s"%vel_mig).split(),logfile=SEP.util.temp_file(),verb=verb)
  if image_exist==0:
    SEP.spawn.run_wait(("Rm3d %s"%image).split(),logfile=SEP.util.temp_file(),verb=verb)
  
sys.exit(0)





