#!/usr/bin/env python
import SEP.opt_solver
import SEP.cgstep
import SEP.superset
import SEP.spawn
import SEP.par
import string
import SEP.sep_vector
import sys
SEP.util.debug=1


args=SEP.par.sep_args() #get arguments
dname,err1=args.par("data")
mname,err2=args.par("model")
if err1==0 or err2==0: SEP.util.err("Must provide model and data")

data =SEP.sep_vector.scmplx(tag=dname)
model=SEP.sep_vector.scmplx(name=mname)

n,o,d,label,unit=data.axis(1)
model.set_axis(1,n,o,d,label,unit)

n,o,d,label,unit=data.axis(2)
model.set_axis(2,n,o,d,label,unit)

n,err1=args.par("apx_n")
o,err2=args.par("apx_o")
d,err3=args.par("apx_d")
if  err1==0 or err2==0 or err3==0: SEP.util.err("must provide apx_n, apx_o, and apx_d")

n,o,d,label,unit=data.axis(4)
model.set_axis(4,n,o,d,label,unit)


n,err1=args.par("az__n")
o,err2=args.par("az__o")
d,err3=args.par("az__d")
model.set_axis(4,n,o,d,"depth","none")
model.write_file()
model.zero()

preconditioning=args.par("preconditioning",1)

if preconditioning==1:
   prec1=SEP.par.sep_pars(name="prec1")
   prec2=SEP.par.sep_pars(name="prec2")
   prec1.add_param(">","/dev/null")
   prec2.add_param(">","/dev/null")

   mutebeg,err1=args.par("mutebeg")
   if err1==1:
     prec1.add_param("mutebeg",mutebeg)
     prec2.add_param("mutebeg",mutebeg)
   muteend,err1=args.par("muteend")
   if err1==1:
     prec1.add_param("muteend",muteend)
     prec2.add_param("muteend",muteend)
   prec1.add_param("forw",0)
   prec2.add_param("forw",1)
   prec1.add_param("prec",1)
   prec2.add_param("prec",1)
   prec1op=SEP.opt_operator.oc_operator("geo_leak.x",model,model,pars=prec1,
      name="prec_back")
   prec2op=SEP.opt_operator.oc_operator("geo_leak.x",model,model,pars=prec2,
      name="prec_forw")
   prec=SEP.opt_operator.row_op("prec",[prec1op,prec2op])

   
interp_args.add_param("coord","coord.H")
interp_args.add_param(">","/dev/null")


regprec=SEP.par.sep_pars(name="devnull")
regprec.add_param(">","/dev/null")
regprec.add_param("filter",2)

interp=SEP.opt_operator.oc_operator("Interp1.x",model,data,pars=interp_args)

reg=SEP.opt_operator.oc_operator("reg.x",model,model,pars=regprec)
prec=SEP.opt_operator.oc_operator("prec.x",model,model,pars=regprec)

                                                                                   
step=SEP.cgstep.cgstep("matcg")


                                                                                
#solver=SEP.opt_solver.solver_reg("interp1d",model,data,interp,reg,step,10,.1,verb=1)
solver=SEP.opt_solver.solver_prec("interp1d",model,data,interp,prec,step,20,.1,verb=1)
if not solver.solve():
  SEP.util.err( "Trouble iterating")
#solver.clean();
