import commands,string,sys,os
import SEP.par
import SEP.sepfile
import SEP.wei_oper
import SEP.wei_code
import SEP.spawn
import SEP.util
import marie_util


def mig_args(args):
  arg2=marie_util.extract_pars(args,"mig_")
  D=SEP.sepfile.sep_file(file=args.par("D",error=1)[0])
  n,o,d,label,unit=D.axis(1)
  arg2.add_string("amx_n=%d amx_o=%f amx_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(2)
  arg2.add_string("amy_n=%d amy_o=%f amy_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(3)
  arg2.add_string("ahx_n=%d ahx_o=%f ahx_d=%f"%(int(n),float(o),float(d)))
  arg2.add_param("apx_n",args.par("apx_n",n)[0])

  n,o,d,label,unit=D.axis(4)
  arg2.add_string("ahy_n=%d ahy_o=%f ahy_d=%f"%(int(n),float(o),float(d)))
  arg2.add_param("apy_n",args.par("apy_n",n)[0])

  n,o,d,label,unit=D.axis(5)
  arg2.add_string("aw__n=%d aw__o=%f aw__d=%f"%(int(n),float(o),float(d)))
  D=SEP.sepfile.sep_file(file=args.par("D",error=1)[0])

  list_required=["az__n","az__o","az__d"]
  for v in list_required: arg2.add_param(v,args.par(v,error=1)[0])

  opt_list=["ray_par","nzb","nwb","velocity","image_real","verb","pverb","npad_x","npad_y"]
  opt_defa=[     "y",   "1",   "1",   "y",       "n",        "n",    "n","0","0"]
  opt_list.extend(["apy_o","apy_d","apx_o","apx_d"])
  opt_defa.extend(["0.",   ".0075","0.",   ".0075"])
   
  for i in range(len(opt_list)):
    arg2.add_param(opt_list[i],args.par(opt_list[i],opt_defa[i])[0])
    
     
  return arg2


def prep_mig(args):
  arg2=mig_args(args) 
  velfile=args.par("S",error=1)[0]
  R=args.par("R",error=1)[0]
  arg2.add_param("R",R)

  S=SEP.sepfile.sep_file(file=velfile)
  n,o,d,label,unit=S.axis(1)
  oz=float(arg2.par("az__o",error=1)[0])
  dz=float(arg2.par("az__d",error=1)[0])
  nz=int(arg2.par("az__n",error=1)[0])
  o=args.param("z_record",0.)
  ndim=S.ndims()
  if o!= oz:
    arg2.add_string("first_dz=%f"%(oz+dz))
  com="Interp  type=1 <%s n1out=%d o1out=%f d1out=%f |"%(velfile, nz,oz,dz)
  velmig="mig_%s"%velfile

  quick=args.logic("quick")
  if S.ndims()==2: com+="Transp plane=12 |Transp plane=23 >%s"%velmig
  else: com+="Transp plane=12 reshape=1,3  >%s"%velmig
  restart=marie_util.logic("restart",args)
  if not restart or quick:
    SEP.spawn.run_wait(com,logfile=SEP.util.temp_file())

  refvel="schoice_%s"%velfile
  pars=marie_util.extract_pars(args,"lloyd_").return_par_string()
  com="/net/koko/bob/bin/LINUX/Lloyd_vel.x  < %s %s >%s"%(velmig,pars,refvel)
  if not restart or quick:
    SEP.spawn.run_wait(com,logfile=SEP.util.temp_file())
  arg2.add_string("schoice=%s S=%s"%(refvel,velmig))
  prog_name=args.par("prog","/net/koko/marie/bin/LINUX/Phase.x")[0]
#  print "THE PROGRAM",prog_name
  prog="/scr1/marie/%s"%os.path.basename(prog_name)
  SEP.spawn.run_wait("cp %s %s"%(prog_name,prog))
  return arg2,prog

def mig_oper(args,migration):
  mig_par,prog=prep_mig(args)
  logdir=args.par("logdir","/scr1/marie/wei_log")[0]
  if migration:
    mig_par.add_string("D=%s"%args.par("D",error=1)[0])
    return SEP.wei_oper.wei_ang_migration(mig_par,prog=prog,logdir=logdir,
     **args.extract_del_pars("par_").return_dict())
  else:
    if marie_util.logic("ray_par",mig_par):
      return SEP.wei_oper.wei_ang(mig_par,prog=prog,logdir=logdir,
       **args.extract_del_pars("par_").return_dict())
    else:
      return SEP.wei_oper.wei(mig_par,prog=prog,logdir=logdir,
       **args.extract_del_pars("par_").return_dict())
