#!/usr/bin/env python
import SEP.operator
import SEP.par
import marie_util


prog="/net/koko/marie/bin/LINUX/geo_leak.x"
prog2="/net/koko/marie/bin/LINUX/geologic.x"

def base_args(args):
  par=marie_util.extract_pars(args,"style_")
  par.add_param(">","/dev/null")
  return par

def mute_op(args,model):
  par=base_args(args)
  par.add_string("prec=0 forw=1")
  prog2="/net/koko/marie/bin/LINUX/mute_prog.x"
  return SEP.operator.oc(prog2,model,model,pars=par)

def reg_for(args,model):
  par=base_args(args)
  par.add_string("prec=0 forw=1")
  return SEP.operator.oc(prog,model,model,pars=par)

def reg_back(args,model):
  par=base_args(args)
  par.add_string("prec=0 forw=0")
  return SEP.operator.oc(prog,model,model,pars=par)

def reg_geol(args,model):
  par=base_args(args)
  par.add_string("prec=0")
  return SEP.operator.oc(prog2,model,model,pars=par)

def prec_for(args,model):
  par=base_args(args)
  par.add_string("prec=1 forw=1")
  return SEP.operator.oc(prog,model,model,pars=par)

def prec_back(args,model):
  par=base_args(args)
  par.add_string("prec=1 forw=0")
  return SEP.operator.oc(prog,model,model,pars=par)

def prec_geol(args,model):
  par=base_args(args)
  par.add_string("prec=1 geol=1")
  return SEP.operator.oc(prog2,model,model,pars=par)

def reg_op(args,model):
  return SEP.operator.chain("reg_chain",
   [reg_for(args,model),reg_back(args,model)],marie_util.logic("restart",args))

def prec_op(args,model):
#    return prec_for(args,model)
#		return mute_op(args,model)
  if(marie_util.logic("mute",args)):
    return SEP.operator.chain("prec_chain",
     [mute_op(args,model),prec_for(args,model)],marie_util.logic("restart",args))
  else:
    return prec_for(args,model)

def prec_geol_op(args,model):
#    return prec_for(args,model)
#		return mute_op(args,model)
  return SEP.operator.chain("geol",
   [mute_op(args,model),prec_geol(args,model)],marie_util.logic("restart",args))
