import SEP.solver
import SEP.operator
import SEP.paths




class reg(SEP.solver.reg):
    def __init__(self,name,m,d,op,reg,stepper,niter,eps,wop=None,rm0=None,
       m0=None,resd=None,verb=None,restart=None,rmov=None,mmov=None):
       SEP.solver.reg.__init__(self,name,m,d,op,reg,stepper,niter,eps,wop,rm0,
       m0,resd,verb,restart)
       self.rmov=rmov
       self.mmov=mmov
       self.niter=niter

    def end_iter (self,iter):
       if self.rmov and iter==0: 
          file=self.rr.clone(name="%s.%d"%(self.rmov,iter))
       if self.rmov and iter==self.niter-1: 
          file=self.rr.clone(name="%s.%d"%(self.rmov,iter))
       if self.mmov:
          file=self.m.clone(name="%s.%d"%(self.mmov,iter))
          SEP.spawn.run_wait("%s/Real < %s >%s.%d"%(SEP.paths.sepbindir,self.m.name,self.mmov,iter))
       return 1
       

class prec(SEP.solver.prec):
    def __init__(self,name,m,d,op,prec,stepper,niter,eps,wop=None,rm0=None,
       m0=None,resd=None,verb=None,restart=None,rmov=None,mmov=None):
       SEP.solver.prec.__init__(self,name,m,d,op,prec,stepper,niter,eps,wop,rm0,
       m0,resd,verb,restart)
       self.rmov=rmov;
       self.mmov=mmov;
       self.niter=niter
       if self.mmov:
         self.temp_file=self.m.clone_space(name="%s.%s"%(self.mmov,"AAA"))
         self.temp_file.zero()
         self.temp_file.write_file()
     
    def end_iter(self,iter):
       if self.rmov and iter==0: 
          file=self.rr.clone(name="%s.%d"%(self.rmov,iter))
       if self.rmov and iter==self.niter-1: 
          file=self.rr.clone(name="%s.%d"%(self.rmov,iter))
       if self.mmov: 
         self.prec.forward(self.p,self.temp_file)
         SEP.spawn.run_wait("%s/Real < %s >%s.%d"%(SEP.paths.sepbindir,self.temp_file.name,self.mmov,iter))
       return 1


class twerp(SEP.solver.smp):
    def __init__(self,name,m,d,op,prec,stepper,niter,wop=None,rm0=None,
       m0=None,resd=None,verb=None,restart=None,rmov=None,mmov=None):
       new_op=SEP.operator.chain("prec_chain",[prec,op],restart)
       p=prec.domain.clone(name="%s.prec"%(m.name))
       self.mod=m
       SEP.solver.smp.__init__(self,name,p,d,new_op,stepper,niter,wop,
       verb=verb,restart=restart)
       self.rmov=rmov
       self.mmov=mmov
       self.prec=prec
       self.niter=niter
       if self.mmov:
         self.temp_file=self.m.clone(name="%s.%s"%(self.mmov,"AAA"))
     
    def end_iter(self,iter):
       if self.mmov: 
         self.prec.forward(self.m,self.temp_file)
         SEP.spawn.run_wait("%s/Real < %s >%s.%d"%(SEP.paths.sepbindir,self.temp_file.name,self.mmov,iter))
       return 1
    def solve(self):
      """Solve for a model"""
      if not self.iter(): return None
      self.prec.forward(self.m,self.mod)
      return 1


