module mute_mod
  use sep
  implicit none

	integer, private :: taperx,tapery
	integer, private,allocatable :: ng(:) 
	integer, private,allocatable    :: intbegmute(:,:,:),intendmute(:,:,:)
	real, private    :: halfpi

contains

  !----------------------------------------------------------------
  subroutine mute_init(nreg,opx,dpx,mute,mute_modbeg)
		integer, intent(in) :: nreg(:)
		real, intent(in) :: opx,dpx 
  	logical :: mute_beg,mute
		real,allocatable    :: begmute(:,:,:),endmute(:,:,:)
    logical,            optional   :: mute_modbeg
		integer  :: iz,ix,iy,ithread,ierr
		integer, external :: sreed
    character(len=128) :: junk

    mute_beg=.false.; if(present(mute_modbeg)) mute_beg=mute_modbeg 

		allocate(ng(size(nreg)))

		ng=nreg


! What is the best way to get the mute in here?
		if(ng(4) .ne. 1) call seperr("h_y must equal 1 - CAM")

		allocate(endmute(ng(1),ng(2),ng(5)),intendmute(ng(1),ng(2),ng(5))) 
		allocate(intbegmute(ng(1),ng(2),ng(5)))
		intbegmute=1
		intendmute=ng(3)
		call from_param("taperx",taperx,5)

if(mute) then
  call from_param("muteend",junk,junk)
  call from_aux("muteend","n1",ierr)
end if
		if(mute_beg) then
			allocate(begmute(ng(1),ng(2),ng(5)))
			if(ng(1)*ng(2)*ng(5)*4 .ne. sreed("mutebeg",begmute,size(begmute)*4)) &
				call seperr("trouble reading mutebeg") 
		end if
    if(mute) then
		  if(ng(1)*ng(2)*ng(5)*4 .ne. sreed("muteend",endmute,size(endmute)*4)) &
	 		call seperr("trouble reading muteend") 
    else
      endmute=opx+dpx*ng(3)
    end if
		do iz=1,ng(5)
			do iy=1,ng(2)
				do ix=1,ng(1)
					if(mute_beg) then
						intbegmute(ix,iy,iz)=(begmute(ix,iy,iz)-opx)/dpx+1.5
						if(intbegmute(ix,iy,iz) < 1) intbegmute(ix,iy,iz)=1
						if(intbegmute(ix,iy,iz) >ng(3)) intbegmute(ix,iy,iz)=ng(3)
					end if
					intendmute(ix,iy,iz)=(endmute(ix,iy,iz)-opx)/dpx+1.5
					if(intendmute(ix,iy,iz) < 1) intendmute(ix,iy,iz)=1
          if(intendmute(ix,iy,iz) >ng(3)) intendmute(ix,iy,iz)=ng(3)
					if(intendmute(ix,iy,iz) < intbegmute(ix,iy,iz)) intendmute(ix,iy,iz)=intbegmute(ix,iy,iz)
				end do
			end do	
		end do
		halfpi=1.5707963
		if(mute_beg) deallocate(begmute)
    deallocate(endmute)
  end subroutine mute_init
  !----------------------------------------------------------------
  integer function mutemod(adj,add, x_,yy_)  result(stat)
    logical,               intent(in)  :: adj,add
    character(len=128),    intent(in)  :: x_,yy_
    integer                            :: i,j,ithread,ierr
		integer  :: iz,ix,iy,nlen
    integer, external :: sreed,sseek
		complex, dimension(:,:,:,:), allocatable :: resid_in, resid_out 




		allocate(resid_in(ng(1),ng(2),ng(3),ng(4)))
		allocate(resid_out(ng(1),ng(2),ng(3),ng(4)))
	
		resid_out=0
		resid_in=0

	
			if(.not. adj) then  !! x=w y{
				 do iz=1,ng(5)	
        	ierr=sreed(x_,resid_in,8*product(ng(1:4)))
          if(add) then
        	  ierr=sreed(yy_,resid_out,8*product(ng(1:4)))
        	  ierr=sseek(yy_,-8*product(ng(1:4)),1)
          else 
					  resid_out=0
          end if 
					do iy=1,ng(2)
						do ix=1,ng(1)
						 resid_out(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)=&
						 resid_out(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)+&
              resid_in(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)

            nlen=min(ng(3) - intendmute(ix,iy,iz), taperx)
!					 do i=1,nlen
!							resid_out(ix,iy,intendmute(ix,iy,iz)+i,:)=&
!							resid_out(ix,iy,intendmute(ix,iy,iz)+i,:)+resid_in(ix,iy,intendmute(ix,iy,iz)+i,:)*((cos((halfpi/nlen)*(i-1)))**2)	
!					 end do
						end do
					end do 
				 call sep_write(resid_out, yy_)	
				end do

			else                     !! y=w x !}{
				 do iz=1,ng(5)	
        	ierr=sreed(yy_, resid_out, 8*product(ng(1:4)))
          if(add) then
        	  ierr=sreed(x_,resid_in,8*product(ng(1:4)))
        	  ierr=sseek(x_,-8*product(ng(1:4)),1)
          else 
					  resid_in=0
          end if 
					do iy=1,ng(2)
						do ix=1,ng(1)

						 resid_in(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)=&
                resid_in(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)+resid_out(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)
           nlen=min(ng(3) - intendmute(ix,iy,iz), taperx)
!					 do i=1,nlen
!							resid_in(ix,iy,intendmute(ix,iy,iz)+i,:)=&
!	  						resid_in(ix,iy,intendmute(ix,iy,iz)+i,:)+resid_out(ix,iy,intendmute(ix,iy,iz)+i,:)*((cos((halfpi/nlen)*(i-1)))**2)	
!					 end do
						end do
					end do 
				 call sep_write(resid_in, x_)	
				end do

			end if !}

				 deallocate(resid_in,resid_out)
 		     stat = 0
  end function mutemod


end module mute_mod
